/*
Copyright 2022 George Bartolomey

Этот файл — часть Kabio.

Kabio — свободная программа: вы можете перераспространять ее и/или изменять ее на условиях Стандартной общественной лицензии GNU в том виде, в каком она была опубликована Фондом свободного программного обеспечения; либо версии 3 лицензии, либо (по вашему выбору) любой более поздней версии.

Kabio распространяется в надежде, что она будет полезной, но БЕЗО ВСЯКИХ ГАРАНТИЙ; даже без неявной гарантии ТОВАРНОГО ВИДА или ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Подробнее см. в Стандартной общественной лицензии GNU.

Вы должны были получить копию Стандартной общественной лицензии GNU вместе с этой программой. Если это не так, см. <https://www.gnu.org/licenses/>.
*/
#include "gui.hpp"
#include <QApplication>
#include <QTranslator>
#include <QIcon>
#include "ringbuffer/ringbuffer.hpp"

using namespace kabio;

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);
    QIcon icon(":/icon.png");
    app.setWindowIcon(icon);
    QTranslator translator;
    QString defaultLocale = QLocale::system().name(); // e.g. "de_DE"
    defaultLocale.truncate(defaultLocale.lastIndexOf('_')); // e.g. "de"
    translator.load(":/lang/" + defaultLocale);
    app.installTranslator(&translator);
    GUI gui;
    gui.show();

    return app.exec();
}

